import { _ as _applyDecoratedDescriptor, a as _initializerDefineProperty, b as _defineProperty } from '../_rollupPluginBabelHelpers-d28022b6.js';
import { setComponentTemplate } from '@ember/component';
import { hbs } from 'ember-cli-htmlbars';
import Component from '@glimmer/component';
import { inject } from '@ember/service';
import { next } from '@ember/runloop';
import { LifecycleResource, useResource } from 'ember-resources';

var TEMPLATE = hbs`{{#if this.renderInPlace}}
  {{yield}}
{{else if this.target}}
  {{#if this.target.multiple}}
    {{#in-element this.target.element insertBefore=null}}
      {{yield}}
    {{/in-element}}
  {{else}}
    {{#in-element this.target.element}}
      {{yield}}
    {{/in-element}}
  {{/if}}
{{/if}}
`;

var _dec, _class, _descriptor;
let PortalTrackerResource = (_dec = inject('-portal'), (_class = class PortalTrackerResource extends LifecycleResource {
  constructor(...args) {
    super(...args);

    _initializerDefineProperty(this, "portalService", _descriptor, this);

    _defineProperty(this, "_target", void 0);
  }

  get target() {
    return this.portalService.getTarget(this._target);
  }

  setup() {
    this._target = this.args.positional[0];
    next(() => this.portalService.registerPortal(this._target));
  }

  update() {
    const previousTarget = this._target;
    const newTarget = this.args.positional[0];
    next(() => {
      this.portalService.registerPortal(newTarget);
      this.portalService.unregisterPortal(previousTarget);
    });
    this._target = newTarget;
  }

  teardown() {
    this.portalService.unregisterPortal(this._target);
  }

}, (_descriptor = _applyDecoratedDescriptor(_class.prototype, "portalService", [_dec], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: null
})), _class));
class PortalComponent extends Component {
  constructor(...args) {
    super(...args);

    _defineProperty(this, "tracker", useResource(this, PortalTrackerResource, () => [this.args.target]));
  }

  get target() {
    return this.tracker.target;
  }

  get renderInPlace() {
    return this.args.renderInPlace === true || !this.target && this.args.fallback === 'inplace';
  }

}
setComponentTemplate(TEMPLATE, PortalComponent);

export { PortalComponent as default };
